/*
 * sgpXmlRpcGateway.java
 *
 * Created on July 26, 2004, 11:27 AM
 */

package sgpAccess;
import org.apache.xmlrpc.XmlRpcClientLite;
import java.util.*;

/**
 *
 * @author  rlawson
 */
public class sgpXmlRpcGateway extends sgpGateway  {
    
    /** Creates a new instance of sgpXmlRpcGateway */
    public sgpXmlRpcGateway() {
    }
    
    public String PSF_say_hello() {
        String retVal = "NaN";
        try {
            XmlRpcClientLite xmlrpc = new XmlRpcClientLite("http://192.168.1.101:8080/server.pl");
            String methodName = "PerlSystemFacade.say_hello";
            Vector params = new Vector(0);

            retVal = (String) xmlrpc.execute( methodName, params );
        
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return retVal;
    }
    
    public void async_PSF_say_hello() {
        String retVal = "NaN";
        try {
            XmlRpcClientLite xmlrpc = new XmlRpcClientLite("http://192.168.1.101:8080/server.pl");
            String methodName = "PerlSystemFacade.say_hello";
            Vector params = new Vector(0);
            asyncHandler ash = new asyncHandler();
            xmlrpc.executeAsync( methodName, params, ash );       
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return;
    }
     
    public Object PSF_echo_args() {
        Object retVal = new Vector();
        try {
            XmlRpcClientLite xmlrpc = new XmlRpcClientLite("http://192.168.1.101:8080/server.pl");
            String methodName = "PerlSystemFacade.echo_args";
            Vector params = new Vector(2);
            Hashtable hashArg = new Hashtable();
            hashArg.put("SessionID",  "127RICHSESSION");
            hashArg.put("ClientIP", "10.1.1.22");
            params.add( hashArg );
            
            retVal = xmlrpc.execute( methodName, params );
        
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return retVal;
    }
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        sgpXmlRpcGateway gateway  =  new sgpXmlRpcGateway();
        System.out.println ( gateway.PSF_echo_args().toString() );
        
        // run it asynchronously for several calls
        for ( int i = 0; i<3; i++) {
            try {
                System.out.println("---- " + i + " ------------------");
                gateway.async_PSF_say_hello();
            }
            catch (Exception ex) 
            { ex.printStackTrace(); }
            
        }
    }
    
    class asyncHandler implements org.apache.xmlrpc.AsyncCallback {
        public void handleError(Exception exception, java.net.URL uRL, String str) {
            System.out.println("handleError called at " + uRL.toString() + " str= " + str );
            if (exception != null ) exception.printStackTrace();
        }

        public void handleResult(Object obj, java.net.URL uRL, String str) {
            System.out.println("handleResult called at " + uRL.toString() + " str=" + str);
            System.out.println("obj= " + obj.toString() );
        }
    }
    
}
